mode(1)
//
// Demo of assert_comparecomplex.sci
//

// Compare real values
assert_comparecomplex ( 1 , -1 , [%eps 0] ) // 1
[order,msg] = assert_comparecomplex ( 1 , -1 , [%eps 0] )
assert_comparecomplex ( -1 , 1 , [%eps 0] ) // -1
assert_comparecomplex ( 1 , 1 , [%eps 0] ) // 0
halt()   // Press return to continue
 
// Compare complex values #1
assert_comparecomplex ( 1+2*%i , 1+3*%i , [%eps 0] ) // -1
assert_comparecomplex ( 1+3*%i , 1+2*%i , [%eps 0] ) // 1
assert_comparecomplex ( 1+2*%i , 1+2*%i , [%eps 0] ) // 0
halt()   // Press return to continue
 
// Compare complex values #2
tol = [%eps 0]
assert_comparecomplex ( 1+%i , -1+%i , tol ) // 1
assert_comparecomplex ( -1+%i , 1+%i , tol ) // -1
assert_comparecomplex ( 1+%i , 1+%i , tol ) // 0
[order,msg] = assert_comparecomplex ( 1+%i , 1+%i , tol )
halt()   // Press return to continue
 
// Compare with tolerances : equality cases
assert_comparecomplex ( 1.2345+%i , 1.2346+%i , [%eps 1.e-3] ) // 0
assert_comparecomplex ( 1.2345+%i , 1.2346+%i , [1.e12*%eps 0] ) // 0
assert_comparecomplex ( 1+1.2345*%i , 1+1.2347*%i , [%eps 1.e-3] ) // 0
assert_comparecomplex ( 1+1.2345*%i , 1+1.2347*%i , [1.e12*%eps 0] ) // 0
halt()   // Press return to continue
 
// Compare more realistic data
x = [
-0.123452 - 0.123454 * %i
-0.123451 + 0.123453 * %i
0.123458 - 0.123459 * %i
0.123456 + 0.123457 * %i
];
// Consider less than 4 significant digits
tol = [1.e-4 0];
for i = 1 : size(x,"*")-1
order = assert_comparecomplex ( x(i) , x(i+1) , tol );
mprintf("compare(x(%d),x(%d))=%d\n",i,i+1,order)
end
halt()   // Press return to continue
 
// Compare data from bug #415
x = [
-1.9914145
-1.895889
-1.6923826
-1.4815461
-1.1302576
-0.5652256 - 0.0655080 * %i
-0.5652256 + 0.0655080 * %i
0.3354023 - 0.1602902 * %i
0.3354023 + 0.1602902 * %i
1.3468911
1.5040136
1.846668
1.9736772
1.9798866
];
// Consider less than 4 significant digits
tol = [1.e-5 0];
for i = 1 : size(x,"*")-1
[order,msg] = assert_comparecomplex ( x(i) , x(i+1) , tol );
mprintf("compare(x(%d),x(%d))=%d (%s)\n",i,i+1,order,msg)
end
halt()   // Press return to continue
 
//========= E N D === O F === D E M O =========//
//
// Load this script into the editor
//
filename = "assert_comparecomplex.sce";
dname = get_absolute_file_path(filename);
editor ( dname + filename );
