// Copyright (C) 2008-2009 - INRIA - Michael Baudin
// Copyright (C) 2010 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function order = assert_compare ( x , y )
  //   The default comparison function used in the sort-merge.
  //
  // Calling Sequence
  //   order = assert_sortcomp ( x , y )
  //
  // Description
  //   Returns -1 if x < y, returns 0 if x==y, returns +1 if x > y
  //
  // Examples
  //   order = assert_compare ( 1 , -1 ) // 1
  //   order = assert_compare ( -1 , 1 ) // -1
  //   order = assert_compare ( 1 , 1 ) // 0
  //
  // Authors
  // Bruno Pincon, 2008, "Quelques tests de rapidite entre differents logiciels matriciels"
  // Michael Baudin, DIGITEO, 2009-2010 (to manage a comparison function)

  if ( x < y ) then
    order = -1
  elseif ( x==y ) then
    order = 0
  else 
    order = 1
  end
endfunction

